# frozen_string_literal: true
=begin


# exemple d'utilisation
=begin
  hr = Hermes::HousingRequest.find("5e3d823ca70bf25ace59e9eb")
 so=Hermes::BoClient::AddRequestTask.new({housing_request_id: hr.id})
 so.to_xml
ExecuteSopraTaskJob.perform_now(so.endpoint, so.to_xml)
=end
=begin

arr =  ["5ee3da0f3db59f03b9112c7b","5ee62be93db59f6a6d7fe64f","5ee69e7b3db59f5ae0e0ab54","5ee874707bb82e7b31505ecc","5ee87d037bb82e2184296f52","5ee887fb3db59f3d8e97bd70","5ee88cb13db59f656f44a74c","5ee895fc7bb82e49f88f52a2","5ee8a1da7bb82e7c8549caee","5ee8a25d3db59f1782afbf66","5ee8a3dd3db59f17835315e5","5ee8a5817bb82e7c84023b95","5ee8aa3b3db59f3cc262f3d9","5ee8b8683db59f62b41f85ab","5ee8c3717bb82e6d263e7dd4","5ee8d4243db59f2e012bad9a","5ee8d4fb7bb82e13ecc62dce","5ee8d5313db59f2e012bb31a","5ee8d5b73db59f2e012bb5ba","5ee8d8947bb82e13ecc64267","5ee8dc2d3db59f4ab49586a1","5ee8dcd37bb82e31e9e20484","5ee8e7e17bb82e5711a0aeb0","5ee8ecef3db59f0385269b3b","5ee8f6dc3db59f0384c641a3","5ee8f9357bb82e6f5477e8e4","5ee8f9403db59f038526f1b8","5ee8fb243db59f367a2f63fe","5ee902b67bb82e3d08ea5f04","5ee903437bb82e3d08ea6260","5ee9152b3db59f656cbe2e23","5ee915423db59f664c0dfc6f","5ee952d77bb82e5c31deac6a","5ee95ce33db59f5ed391e589","5ee9720f3db59f2c7bbe85f0","5ee985703db59f50c135abd5","5ee999a03db59f16692746a1","5ee9a5dc3db59f3993a2b2b3"]

arr.length
arr.each_with_index do |id, i|
  hr = Hermes::HousingRequest.find_by(id: id)
  if hr && hr.nuds && hr.nuds.length > 0
    hr.nuds.each do |nud|
      if nud.unique_number.length == 18
        so = Hermes::BoClient::AddRequestTask.new(housing_request_id: hr.id, nud_id: nud.id)
        so.to_xml
        ExecuteSopraTaskJob.perform_now(so.endpoint, so.to_xml, "post", "Hermes::HousingRequest", hr.id.to_s)
    ap i
      end
    end
  else
    ap hr
    ap i.to_s + " _error"
  end
end

=end


module Hermes
  module BoClient
    class AddRequestTask < BaseTask
      
      def initialize(options = {})
        @xsd = "InterfaceNuu_v0300.xsd"
        super(options)
      end
      
      endpoint {'/ws/rest/als/demande/v1/integrer'}
      
      task_name 'addrequest'
      type_flux 'BIEN'
      mapping 'Hermes::BoClient::Mappings::HousingRequestMap'
      
      params *%i[
                numGuichet
                refInterne
                dateCreationDemande
                forcerDoublon
                renouvellementElec
                categorieLogementRecherche
                rezDeChaussee
                sansAscenseur
                montantLoyer
                demandeElargie
                typeLogement
                commune
                codePostal
                motifDemande
                civilite
                nom
                prenom
                dateNaissance
                nationalite
                situationFamiliale
                etranger
                batiment
                numero
                voie
                codePostal
                commune
                typeContratTravail
                multiEmployeur
                anneeMoins1
                montantMoins1
                etranger
                numero
                voie
                codePostal
                commune
                modeleLogement
                montantMensuelLoyer
                montantMensuelAPL
                nombreHabitant
                surface
                proprietaire
                etranger
            }
      ]
      
      def add_if_exists(b, item_name, mapping_name = nil, is_code = false)
        mapping_name ||= item_name
        mapping_value = mapping.send(mapping_name)
        
        b.send(item_name, is_code ? {"code" => mapping_value} : mapping_value) unless mapping_value == nil
      
      end

      def need_to_add_work_info(typeContratTravail, foreign)
        foreign == 1 || ['CDIP', 'AGP', 'CDD', 'APP'].include?(typeContratTravail) 
      end 
      
      def to_xml
        xml_res = ""
        if( mapping.send("xml"))
          xml_res += mapping.send("xml").split("</ns1:numUnique>")[0] 
          xml_res += "</ns1:numUnique><ns1:refInterne>" + mapping.send("refInterne") + "</ns1:refInterne><ns1:dateCreationDemande>" 
          xml_res += mapping.send("xml").split("<ns1:dateCreationDemande>")[1] 
        end
        return xml_res
      end
    end
  end
end
