
require 'csv'

raise 'You need to load this script througth a require' unless __FILE__
# Replace following variables if need
FILE_TYPE = 'csv'
FILE_PATH = "."
def run_script(skip)
  start_time = Time.now
  formated_t = start_time.strftime('%d-%m-%Y-%H:%M')
  puts "Start script at #{start_time}"
  file_name   = "#{HERMES_CONFIG['environment']}-#{formated_t}-#{__FILE__.split('/').last.gsub('.rb', ".#{FILE_TYPE}")}"
  file_class  = FILE_TYPE == 'csv' ? CSV : File
  file        = file_class.open("#{FILE_PATH}/#{file_name}", 'ab')
  ##############################################################################
  ##################################__SCRIPT__##################################
  # write the content of the script bellow
  file << [
    "lessor_contact_id",
    "lessor_id",
    "name",
    "email",
    "phone"
  ]
 
  lessors_contacts = Hermes::LessorContact.where({ email: nil})
  count = lessors_contacts.count

  puts("#{count} lessors_contacts with email==nil found")
  lessors_contacts.batch_size(5).each_with_index do |lessors_contact, i|
    begin
      puts "#{i+1}/#{count}"
      line = [
        lessors_contact.id.to_s,
        lessors_contact.lessor_id&.to_s,
        lessors_contact.name,
        lessors_contact.email,
        lessors_contact.phone
      ]
      file << line
      puts line.join(', ')

    rescue Exception => e
      line = ["Erreur de traitement : #{e}"]
      file << [line]
      puts line.join(', ')
    end
  end 
  ##############################################################################
  ##############################################################################
  file.close
  stop_time = Time.now
  puts "Start end at #{stop_time}"
  puts "Executed in #{(stop_time - start_time).seconds}"
end

run_script( 0)